#ifndef _XML_H
#define _XML_H

//
// LocoTool - A program to edit Locomotion object description .dat files
//
// Copyright (C) 2004 by Josef Drexler
//
// This file is distributed under the term of the GNU General Public Licence
// version 2 or higher.  Please read the file LICENCE for details.
//
//
// xml.h - functions to read and parse the xml file
//

#include <stdio.h>

#include "common.h"

// write a character string, encoding < as &gt; etc.
void putxmlstr(FILE *f, const char *str, uint32_t minlen);

// parse an xml file and store the reconstructed object data as
// malloc'ed pointer in outdata
uint32_t parsexml(uint8_t *data, uint32_t len, uint8_t **outdata, int *compression);

// append various structures at the end of the class-specific object data
void addval(xmlinf *inf, uint8_t *val, uint32_t len);	// an array of bytes
void add32(xmlinf *inf, uint32_t val);			// a 4-byte value
void add16(xmlinf *inf, uint16_t val);			// a 2-byte value
void add8(xmlinf *inf, uint8_t val);			// a single byte
void addobj(xmlinf *inf, int num, useobjid id, int class);// an external object dependence
void addsprites(xmlinf *inf);				// the list and content of all sprites


#endif // ndef _XML_H
